/* Copyright (c) 1996 by Lele Gaifax.  All Rights Reserved
 *
 * This file is part of Nothing (yet).
 *
 * $RCSfile: AlertPanel.h,v $
 * $Revision: 1.1.1.1 $
 * $Date: 1996/09/30 06:06:48 $
 *
 * Created Wed Sep  4 15:21:26 1996.
 */

#ifndef _AlertPanel_H
#define _AlertPanel_H

#include <objc/Object.h>
#include <PythonObject.h>

/*#C This class does something really interesting... */
@interface AlertPanel : Object
{
  const char *mainTitle;
  const char *message;
  const char *defaultButtonTitle;
  const char *alternateButtonTitle;
  const char *otherButtonTitle;
  enum _alert_panel_status
  {
    ALERT_PANEL_READY,
    ALERT_PANEL_DEFAULT,
    ALERT_PANEL_ALTERNATE,
    ALERT_PANEL_OTHER
  } status;

  id <PythonObject> action;
}

//#M Initialize the version number of this class.
+ (void) initialize;

- initWithTitle:(const char *) title;

- initWithTitle:(const char *) title
	message:(const char *) msg;

- initWithTitle:(const char *) title
	message:(const char *) msg
  defaultButton:(const char *) defButton;

- initWithTitle:(const char *) title
	message:(const char *) msg
  defaultButton:(const char *) defButton
      altButton:(const char *) altButton;

- initWithTitle:(const char *) title
	message:(const char *) msg
  defaultButton:(const char *) defButton
      altButton:(const char *) altButton
    otherButton:(const char *) otherButton;

- (void) setAction:(id <PythonObject>) anAction;

- (enum _alert_panel_status) status;

- (enum _alert_panel_status) run;

- (const char *) buttonTitle;

@end /* AlertPanel class interface */


#endif /* _AlertPanel_H */
