#/**
#*** Copyright (c) 1996 by Bill Bumgarner.  All Rights Reserved
#*** 
#*** This software may be used and distributed freely for any purpose
#*** provided that this notice is included unchanged on any and all copies.
#*** The author does not warrant or guarantee this software in any way.
#*** 
#*** 
#*** All queries, patches, and discussions of the PyObjC project should be
#*** directed to <objc-sig@python.org>.  The author can be reached via
#*** <bbum@friday.com>.
#*** 
#*** $RCSfile: PyServicesDaemon.py,v $
#*** 
#*** $Revision: 1.2 $
#*** 
#*** $Date: 1996/10/07 08:30:34 $
#*** 
#**/

from types import *
from Demiurge.DPyClassSupport import \
	 RestrictSetAttribute, UnrestrictSetAttribute, RestrictedSetAttr

import ObjC
import PyServicesDelegate
import sys

ListenerClass			= ObjC.runtime.Listener
PyServicesDelegateClass	= ObjC.runtime.PyServicesDelegate

def newDaemon():
   return PyServicesDaemon()

class PyServicesDaemon:
   def addServicesPort(self, portName, handler, listener = None):
	  if listener == None:
		 listener = ListenerClass()

	  ## set the daemon iVar within the handler (this WOULD raise
	  ## an attribute error if the daemon variable was not
	  ## 'declared' in PyServicesHandler's __init__).
	  handler.daemon = self

	  delegate = PyServicesDelegateClass.newWithHandler__(handler)

	  listener.setServicesDelegate__(delegate)
	  listener.checkInAs__(portName)
	  listener.addPort()

   def run(self):
	  ListenerClass.run()

   def stop(self):
	  ### no other way
	  sys.exit(0)
	  
